function userDir = getuserdir
%GETUSERDIR   return the user home directory.
%   USERDIR = GETUSERDIR returns the user home directory using the registry
%   on windows systems and using Java on non windows systems as a string
%
%   Example:
%      getuserdir() returns on windows
%           C:\Documents and Settings\MyName

if ispc
%     userDir = winqueryreg('HKEY_CURRENT_USER',...
%         ['Software\Microsoft\Windows\CurrentVersion\' ...
%          'Explorer\Shell Folders'],'Personal');
    userDir = getenv('userprofile');
else
    userDir = char(java.lang.System.getProperty('user.home'));
end